require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_HARDIRQ_H)) {
    eval 'sub __SPARC_HARDIRQ_H () {1;}' unless defined(&__SPARC_HARDIRQ_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'linux/brlock.ph';
    require 'linux/spinlock.ph';
    unless(defined(&CONFIG_SMP)) {
    } else {
    }
    require 'linux/irq_cpustat.ph';
    unless(defined(&CONFIG_SMP)) {
	eval 'sub irq_enter {
	    local($cpu, $irq) = @_;
    	    eval q((( &void)($irq),  &local_irq_count($cpu)++));
	}' unless defined(&irq_enter);
	eval 'sub irq_exit {
	    local($cpu, $irq) = @_;
    	    eval q((( &void)($irq),  &local_irq_count($cpu)--));
	}' unless defined(&irq_exit);
    } else {
	undef(&local_irq_count) if defined(&local_irq_count);
	eval 'sub local_irq_count {
	    local($cpu) = @_;
    	    eval q(( $__brlock_array[$cpu][ &BR_GLOBALIRQ_LOCK]));
	}' unless defined(&local_irq_count);
	eval 'sub irq_enter {
	    local($cpu, $irq) = @_;
    	    eval q( &br_read_lock( &BR_GLOBALIRQ_LOCK));
	}' unless defined(&irq_enter);
	eval 'sub irq_exit {
	    local($cpu, $irq) = @_;
    	    eval q( &br_read_unlock( &BR_GLOBALIRQ_LOCK));
	}' unless defined(&irq_exit);
    }
    eval 'sub in_interrupt () {
        eval q((( &local_irq_count( &smp_processor_id()) +  &local_bh_count( &smp_processor_id())) != 0));
    }' unless defined(&in_interrupt);
    eval 'sub in_irq () {
        eval q(( &local_irq_count( &smp_processor_id()) != 0));
    }' unless defined(&in_irq);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub hardirq_trylock {
	    local($cpu) = @_;
    	    eval q((( &void)($cpu),  &local_irq_count( &smp_processor_id()) == 0));
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    local($cpu) = @_;
    	    eval q( &do { ( &void)($cpu); }  &while(0));
	}' unless defined(&hardirq_endlock);
	eval 'sub synchronize_irq () {
	    eval q( &barrier());
	}' unless defined(&synchronize_irq);
    } else {
	eval 'sub irqs_running {
	    local($void) = @_;
    	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &smp_num_cpus;  &i++)  &if ( &local_irq_count( &cpu_logical_map( &i))) 1; 0; });
	}' unless defined(&irqs_running);
	eval 'sub release_irqlock {
	    local($cpu) = @_;
    	    eval q({  &if( &global_irq_holder == $cpu) {  &global_irq_holder =  &NO_PROC_ID;  &br_write_unlock( &BR_GLOBALIRQ_LOCK); } });
	}' unless defined(&release_irqlock);
	eval 'sub hardirq_trylock {
	    local($cpu) = @_;
    	    eval q({  &spinlock_t * &lock = & ($__br_write_locks[&BR_GLOBALIRQ_LOCK]->{lock}); (! &local_irq_count($cpu)  && ! &spin_is_locked( &lock)); });
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    local($cpu) = @_;
    	    eval q( &do { ( &void)($cpu); }  &while (0));
	}' unless defined(&hardirq_endlock);
    }
}
1;
