require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_IO_H)) {
    eval 'sub __SPARC_IO_H () {1;}' unless defined(&__SPARC_IO_H);
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'linux/ioport.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
    eval 'sub page_to_phys {
        local($page) = @_;
	    eval q((((($page) -  &mem_map) <<  &PAGE_SHIFT)+ &phys_base));
    }' unless defined(&page_to_phys);
    eval 'sub flip_dword {
        local($d) = @_;
	    eval q({ (($d&0xff)<<24) | ((($d>>8)&0xff)<<16) | ((($d>>16)&0xff)<<8)| (($d>>24)&0xff); });
    }' unless defined(&flip_dword);
    eval 'sub flip_word {
        local($d) = @_;
	    eval q({ (($d&0xff) << 8) | (($d>>8)&0xff); });
    }' unless defined(&flip_word);
    eval 'sub readw {
        local($addr) = @_;
	    eval q({  &flip_word(*( &volatile  &u16 *)$addr); });
    }' unless defined(&readw);
    eval 'sub readl {
        local($addr) = @_;
	    eval q({  &flip_dword(*( &volatile  &u32 *)$addr); });
    }' unless defined(&readl);
    eval 'sub writeb {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&writeb);
    eval 'sub writew {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr =  &flip_word($b); });
    }' unless defined(&writew);
    eval 'sub writel {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr =  &flip_dword($b); });
    }' unless defined(&writel);
    eval 'sub __raw_readw {
        local($addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr; });
    }' unless defined(&__raw_readw);
    eval 'sub __raw_readl {
        local($addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr; });
    }' unless defined(&__raw_readl);
    eval 'sub __raw_writeb {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&__raw_writeb);
    eval 'sub __raw_writew {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr = $b; });
    }' unless defined(&__raw_writew);
    eval 'sub __raw_writel {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr = $b; });
    }' unless defined(&__raw_writel);
    eval 'sub inb_local {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb_local);
    eval 'sub inb {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb);
    eval 'sub inw {
        local($addr) = @_;
	    eval q( &readw($addr));
    }' unless defined(&inw);
    eval 'sub inl {
        local($addr) = @_;
	    eval q( &readl($addr));
    }' unless defined(&inl);
    eval 'sub inb_p {
        local($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&inb_p);
    eval 'sub outb_local {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb_local);
    eval 'sub outb {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb);
    eval 'sub outw {
        local($b, $addr) = @_;
	    eval q( &writew($b, $addr));
    }' unless defined(&outw);
    eval 'sub outl {
        local($b, $addr) = @_;
	    eval q( &writel($b, $addr));
    }' unless defined(&outl);
    eval 'sub outb_p {
        local($b, $addr) = @_;
	    eval q( &writeb($b, $addr));
    }' unless defined(&outb_p);
    eval 'sub IO_SPACE_LIMIT () {0xffffffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub _sbus_readw {
        local($addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr; });
    }' unless defined(&_sbus_readw);
    eval 'sub _sbus_readl {
        local($addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr; });
    }' unless defined(&_sbus_readl);
    eval 'sub _sbus_writeb {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u8 *)$addr = $b; });
    }' unless defined(&_sbus_writeb);
    eval 'sub _sbus_writew {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u16 *)$addr = $b; });
    }' unless defined(&_sbus_writew);
    eval 'sub _sbus_writel {
        local($b,$addr) = @_;
	    eval q({ *( &volatile  &u32 *)$addr = $b; });
    }' unless defined(&_sbus_writel);
    eval 'sub sbus_readb {
        local($a) = @_;
	    eval q( &_sbus_readb(($a)));
    }' unless defined(&sbus_readb);
    eval 'sub sbus_readw {
        local($a) = @_;
	    eval q( &_sbus_readw(($a)));
    }' unless defined(&sbus_readw);
    eval 'sub sbus_readl {
        local($a) = @_;
	    eval q( &_sbus_readl(($a)));
    }' unless defined(&sbus_readl);
    eval 'sub sbus_writeb {
        local($v, $a) = @_;
	    eval q( &_sbus_writeb($v, ($a)));
    }' unless defined(&sbus_writeb);
    eval 'sub sbus_writew {
        local($v, $a) = @_;
	    eval q( &_sbus_writew($v, ($a)));
    }' unless defined(&sbus_writew);
    eval 'sub sbus_writel {
        local($v, $a) = @_;
	    eval q( &_sbus_writel($v, ($a)));
    }' unless defined(&sbus_writel);
    eval 'sub void {
        eval q(* &sbus_memset_io( &void * &__dst, \'int\'  &c,  &__kernel_size_t  &n) { my $dst =  &__dst;  &while( &n--) {  &sbus_writeb( &c,  $dst);  $dst++; } ( &void *)  $dst; });
    }' unless defined(&void);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap_nocache {
	    local($X,$Y) = @_;
    	    eval q( &ioremap(($X),($Y)));
	}' unless defined(&ioremap_nocache);
	eval 'sub virt_to_phys {
	    local($x) = @_;
    	    eval q( &__pa(($x)));
	}' unless defined(&virt_to_phys);
	eval 'sub phys_to_virt {
	    local($x) = @_;
    	    eval q( &__va(($x)));
	}' unless defined(&phys_to_virt);
	eval 'sub RTC_PORT {
	    local($x) = @_;
    	    eval q(( &rtc_port + ($x)));
	}' unless defined(&RTC_PORT);
	eval 'sub RTC_ALWAYS_BCD () {0;}' unless defined(&RTC_ALWAYS_BCD);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
