require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    die("Never use <bits/mathinline.h> directly; include <math.h> instead.");
}
require 'bits/wordsize.ph';
if(defined(&__GNUC__)) {
    if(defined (defined(&__USE_ISOC99) ? &__USE_ISOC99 : 0)  && ! &__GNUC_PREREQ(3,0)) {
	undef(&isgreater) if defined(&isgreater);
	undef(&isgreaterequal) if defined(&isgreaterequal);
	undef(&isless) if defined(&isless);
	undef(&islessequal) if defined(&islessequal);
	undef(&islessgreater) if defined(&islessgreater);
	undef(&isunordered) if defined(&isunordered);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 32) {
	    eval 'sub __unordered_cmp {
	        local($x, $y) = @_;
    		eval q(( &__extension__ ({ \'unsigned __r\';  &if ($sizeof{$x} == 4 && $sizeof{$y} == 4) { \'float\'  &__x = ($x); \'float\'  &__y = ($y);  &__asm__(\\"fcmps %1,%2; st %%fsr, %0\\" : \\"=m\\" ( &__r) : \\"f\\" ( &__x), \\"f\\" ( &__y) : \\"cc\\"); }  &else { \'double\'  &__x = ($x); \'double\'  &__y = ($y);  &__asm__(\\"fcmpd\\\\t%1,%2\\\\n\\\\tst\\\\t%%fsr,%0\\" : \\"=m\\" ( &__r) : \\"f\\" ( &__x), \\"f\\" ( &__y) : \\"cc\\"); }  &__r; })));
	    }' unless defined(&__unordered_cmp);
	    eval 'sub isgreater {
	        local($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & (3<< 10)) == (2<< 10)));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        local($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & (1<< 10)) == 0));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        local($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & (3<< 10)) == (1<< 10)));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        local($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & (2<< 10)) == 0));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        local($x, $y) = @_;
    		eval q(((( &__unordered_cmp ($x, $y) + (1<< 10)) & (2<< 10)) != 0));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        local($x, $y) = @_;
    		eval q((( &__unordered_cmp ($x, $y) & (3<< 10)) == (3<< 10)));
	    }' unless defined(&isunordered);
	} else {
	    eval 'sub __unordered_v9cmp {
	        local($x, $y, $op, $qop) = @_;
    		eval q(( &__extension__ ({ \'unsigned __r\';  &if ($sizeof{$x} == 4 && $sizeof{$y} == 4) { \'float\'  &__x = ($x); \'float\'  &__y = ($y);  &__asm__(\\"fcmps\\\\t%%fcc3,%1,%2\\\\n\\\\tmov\\" $op \\"\\\\t%%fcc3,1,%0\\" : \\"=r\\" ( &__r) : \\"f\\" ( &__x), \\"f\\" ( &__y), \\"0\\" (0) : \\"cc\\"); }  &else  &if ($sizeof{$x} <= 8 && $sizeof{$y} <= 8) { \'double\'  &__x = ($x); \'double\'  &__y = ($y);  &__asm__(\\"fcmpd\\\\t%%fcc3,%1,%2\\\\n\\\\tmov\\" $op \\"\\\\t%%fcc3,1,%0\\" : \\"=r\\" ( &__r) : \\"f\\" ( &__x), \\"f\\" ( &__y), \\"0\\" (0) : \\"cc\\"); }  &else { \'long double __x\' = ($x); \'long double __y\' = ($y);  &extern \'int\'  &_Qp_cmp( &const \'long double\' * &a,  &const \'long double\' * &b);  &__r = $qop; }  &__r; })));
	    }' unless defined(&__unordered_v9cmp);
	    eval 'sub isgreater {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"g\\",  &_Qp_cmp (& &__x, & &__y) == 2));
	    }' unless defined(&isgreater);
	    eval 'sub isgreaterequal {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"ge\\", ( &_Qp_cmp (& &__x, & &__y) & 1) == 0));
	    }' unless defined(&isgreaterequal);
	    eval 'sub isless {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"l\\",  &_Qp_cmp (& &__x, & &__y) == 1));
	    }' unless defined(&isless);
	    eval 'sub islessequal {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"le\\", ( &_Qp_cmp (& &__x, & &__y) & 2) == 0));
	    }' unless defined(&islessequal);
	    eval 'sub islessgreater {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"lg\\", (( &_Qp_cmp (& &__x, & &__y) + 1) & 2) != 0));
	    }' unless defined(&islessgreater);
	    eval 'sub isunordered {
	        local($x, $y) = @_;
    		eval q( &__unordered_v9cmp($x, $y, \\"u\\",  &_Qp_cmp (& &__x, & &__y) == 3));
	    }' unless defined(&isunordered);
	}
    }
    if((!defined (defined(&__NO_MATH_INLINES) ? &__NO_MATH_INLINES : 0) || defined (defined(&__LIBC_INTERNAL_MATH_INLINES) ? &__LIBC_INTERNAL_MATH_INLINES : 0))  && defined (defined(&__OPTIMIZE__) ? &__OPTIMIZE__ : 0)) {
	if(defined(&__cplusplus)) {
	    eval 'sub __MATH_INLINE () { &__inline;}' unless defined(&__MATH_INLINE);
	} else {
	    eval 'sub __MATH_INLINE () { &extern  &__inline;}' unless defined(&__MATH_INLINE);
	}
	if( &__GNUC_PREREQ (2, 8)) {
	    if(defined(&__USE_ISOC99)) {
		if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 32) {
		} else {
		}
	    }
	    unless(defined(&__NO_MATH_INLINES)) {
		if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 64) {
		}
	    }
	    if(defined(&__LIBC_INTERNAL_MATH_INLINES)) {
		if((defined(&__WORDSIZE) ? &__WORDSIZE : 0) == 64) {
		}
	    }
	}
	if(defined(&__USE_ISOC99)) {
	    unless(defined(&__NO_MATH_INLINES)) {
	    }
	}
    }
}
1;
